*&* PrintJobListener.PRG
*&* (c) Lisa Slater Nicholls >L<


#DEFINE FFC_HOME HOME() + "FFC\"
#DEFINE LISTENER_SUPERCLASSLIB ;
   FFC_HOME + "_reportlistener.vcx"
#DEFINE LISTENER_SUPERCLASS "_ReportListener"

#DEFINE USE_DEFAULT_DPI_GRAPHICS .T.

#DEFINE LISTENER_DPI 960

#DEFINE DEFAULT_DPI_GRAPHICS 96

#DEFINE FAILED_CANNOT_PROCESS_REPORT_LOC    ;
  CHR(13) + CHR(13) + ;
  "Report processing will not continue."

#DEFINE FAILED_COULD_NOT_REMOVE_FRXSETUP_LOC ;
  "The report you chose has saved " + ;
  "printer setup information " + CHR(13) + ;
  "and this application is unable to remove it." + ;
  FAILED_CANNOT_PROCESS_REPORT_LOC

#DEFINE FAILED_COULD_NOT_USE_PRINTSETUPS_LOC ;
  "This application requires a print setup table " + CHR(13) + ;
  "(" + THIS.PrinterSetupTable + ")" + CHR(13) + ;
  "and the table is not available or does not " + CHR(13) + ;
  "include appropriate instructions to match your report." +  ;
  FAILED_CANNOT_PROCESS_REPORT_LOC
  
#DEFINE FAILED_FRXSETUP_RESTORE_LOC  ;
  "The report you chose had saved printer " + ;
  "setup information," + CHR(13) + ;
  "which was removed by this application." + ;
  CHR(13) + CHR(13) + ;
  "Restoration of this information after the report run" + ;
  CHR(13) +;
  "appears to have failed. Please check this report: " + ;
  CHR(13) + CHR(13) + ;
  tFRXFile

#DEFINE PICK_REPORT_LOC  ;
  "Pick a report with at least two pages... "

#DEFINE PICK_PRINTERSETUP1_LOC  ;
  "Pick a printer and " + CHR(13) +;
  "set some characteristics for its " + ;
  m.lcSetup + " setup... "

#DEFINE PICK_PRINTERSETUP2_LOC ;
  "Pick the SAME printer (" + m.lcPrinter + ;
  ") and " + CHR(13) + ;
  "set some DIFFERENT characteristics for its " + ;
  m.lcSetup + " setup... "

#DEFINE PICK_SAME_PRINTER_ALL_SETUPS_LOC ;
  "You must pick the SAME printer (" + m.lcPrinter+ ;
  ") each time." + CHR(13) + ;
  "Try again."

#DEFINE LISTENER_TYPE_DEF    -1
#DEFINE LISTENER_TYPE_PRN     0
#DEFINE LISTENER_TYPE_PRV     1
#DEFINE LISTENER_TYPE_PAGED   2
#DEFINE LISTENER_TYPE_ALLPGS  3

#DEFINE LISTENER_DEVICE_TYPE_HDC    0
#DEFINE LISTENER_DEVICE_TYPE_GRF    1

#DEFINE VFPSTARTMODE_DEV        0
#DEFINE VFPSTARTMODE_APPOBJ     1
#DEFINE VFPSTARTMODE_COMEXE     2
#DEFINE VFPSTARTMODE_INPROCDLL  3
#DEFINE VFPSTARTMODE_DISTAPPEXE 4
#DEFINE VFPSTARTMODE_MTDLL      5

#DEFINE VFP_USER_DEFINED_ERROR  1098

#DEFINE MB_ICONEXCLAMATION      48
#DEFINE MB_ICONSTOP             16

#DEFINE PHYSICALWIDTH   110  && Actual page width  / Physical Width in device units
#DEFINE PHYSICALHEIGHT  111  && Actual page length / Physical Height in device units
#DEFINE PHYSICALOFFSETX 112  && Printable page left margin / Physical Printable Area x margin
#DEFINE PHYSICALOFFSETY 113  && Printable page top margin  / Physical Printable Area y margin
#DEFINE LOGPIXELSX       88  && DPI / Logical pixels/inch in X dimension
#DEFINE LOGPIXELSY       90  && DPI / Logical pixels/inch in Y dimension


LOCAL m.ox, m.oy
m.ox = CREATEOBJECT("PrintJobListener")
m.oy = CREATEOBJECT("Collection")
m.oy.Add(1,"FirstPage")
m.oy.Add(2,"SecondPage")
m.oy.Add(3,"OtherPages")
ox.FRXPrintSetups = m.oy

ox.DoStatus(PICK_REPORT_LOC)

ox.ScalePages = INPUTBOX("Use Stretch, Clip, or Retain " + ;
                "[unknown values=stretch]:", ;
                "Page Scale Type","retain" )

ox.DoMessage(EVL(ox.ScalePages,"stretch"))

REPORT FORM ? OBJECT m.ox 
RETURN

DEFINE CLASS PrintJobListener AS OleAwareReportListener

  ListenerType = LISTENER_TYPE_ALLPGS
  
  ScalePages = ""
  PrinterSetupTable = "PrintSetups.DBF"
  FRXPrintSetups = NULL

  PROTECTED ;
    FRXPrintSourceAlias, FRXPrintTargetAlias, ;
    FRXTempAlias, ;
    HDC, OldPrinterName, OldFRXSetup, ;
    CurrentPrinterName, CurrentPrinterSetupDefaults

  HDC = -1
  FRXPrintSourceAlias = "S" + SYS(2015)
  FRXPrintTargetAlias = "T" + SYS(2015)
  FRXTempAlias = "X" + SYS(2015)
  OldPrinterName = SET("PRINTER",3)
  CurrentPrinterName = ""
  OldFRXSetup = NULL
  CurrentPrinterSetupDefaults = NULL

  PROCEDURE ListenerType_Assign(tVal)
    *&* for now, readonly 
  ENDPROC
  PROCEDURE ScalePages_Assign(tVal)
    IF VARTYPE(m.tVal) = "C"
      m.tVal = UPPER(ALLTRIM(m.tVal))
      IF m.tVal == "" OR ;
        m.tVal == "CLIP" OR ;
        m.tVal == "RETAIN"
        THIS.ScalePages = m.tVal
      ENDIF
    ENDIF
  ENDPROC
  PROCEDURE PrinterSetupTable_Assign(tVal)
    IF VARTYPE(m.tVal) = "C" AND ;
      NOT EMPTY(JUSTFNAME(tVal))
      IF EMPTY(JUSTEXT(tVal))
        tVal = FORCEEXT(tVal,"DBF")
      ENDIF
      IF EMPTY(JUSTPATH(tVal))
        tVal = FORCEPATH(tVal, SYS(2023))
      ENDIF
      THIS.PrinterSetupTable = tVal
    ENDIF
  ENDPROC
  PROCEDURE FRXPrintSetups_Assign(tVal)
    IF VARTYPE(m.tVal) = "O" AND ;
      UPPER(tVal.BASECLASS) == "COLLECTION"
      THIS.FRXPrintSetups = tVal
    ENDIF
  ENDPROC

  PROCEDURE Init()
    THIS.FRXPrintSetups = CREATEOBJECT("Collection")
    RETURN DODEFAULT()
  ENDPROC

  PROCEDURE LoadReport()
    IF NOT ;
      THIS.StripAndSaveFRXSetup(THIS.CommandClauses.FILE)
      THIS.DoMessage(FAILED_COULD_NOT_REMOVE_FRXSETUP_LOC, ;
        MB_ICONSTOP)
      RETURN .F.
    ENDIF
    IF THIS.FRXPrintSetups.Count = 0
      THIS.FRXPrintSetups.Add(1, "AllPages")
    ENDIF
    IF THIS.MultipleSetupsOnePrinter(THIS.FRXPrintSetups)
      THIS.Setup()
    ELSE
      THIS.DoMessage(FAILED_COULD_NOT_USE_PRINTSETUPS_LOC, ;
        MB_ICONSTOP)
      RETURN .F.
    ENDIF
    RETURN DODEFAULT()

  ENDPROC

  PROCEDURE UnloadReport()

    IF THIS.ListenerType = LISTENER_TYPE_ALLPGS AND ;
      THIS.OutputPageCount > 0 AND THIS.HDC # -1 
        && in case it was interrupted or returned .F. from the LoadReport
      *&* handle processing of pages here, for LISTENER_TYPE_ALLPGS
      *&* if you add LISTENER_TYPE_PAGED OR PRN you don't do the processing here.

      LOCAL m.lcDocInfo, m.liStartPage, m.liEndPage, ;
         m.liSetupIndex, m.liSetups

      m.lcDocInfo = CHR(20) + REPLICATE(CHR(0),19) && DOCINFO basic structure - 20 bytes
      = StartDoc(THIS.HDC, @lcDocInfo)

      THIS.SetFRXDataSession()

      m.liEndPage = 0
      m.liSetups = THIS.FRXPrintSetups.Count
      
      FOR m.liSetupIndex = 1 TO m.liSetups

        m.liStartPage = m.liEndPage + 1
        IF m.liSetupIndex < m.liSetups
          m.liEndPage = ;
            THIS.FRXPrintSetups.Item(m.liSetupIndex + 1) - 1
        ELSE
          m.liEndPage = THIS.OutputPageCount
        ENDIF
        IF m.liEndPage < m.liStartPage OR ;
           m.liEndPage > THIS.OutputPageCount
          THIS.ProcessPages(m.liSetupIndex, ;
                            m.liStartPage,;
                            THIS.OutputPageCount)
          EXIT
        ELSE
          THIS.ProcessPages(m.liSetupIndex, ;
                            m.liStartPage,;
                            m.liEndPage)
        ENDIF
      ENDFOR

      THIS.ResetDataSession()

      = EndDoc(THIS.HDC)
    ENDIF
    THIS.Cleanup()
    DODEFAULT()
  ENDPROC

  PROCEDURE SupportsListenerType(tI)
    RETURN VARTYPE(tI) = "N" AND ;
      INLIST(tI,LISTENER_TYPE_ALLPGS ) AND ;
      (NOT THIS.IsSuccessor)
    *&* LISTENER_TYPE_PAGED or _PRN supported also?
    *&* Possible, a lot harder, not in this version.

    *&* Can't be successor
    *&* because we're going to
    *&* communicate with the engine
  ENDPROC
  
  *&* PUBLIC callable methods added in this class:

  PROCEDURE StripAndSaveFRXSetup(tFRXFile) 
    LOCAL m.llSuccess, m.liSelect
    THIS.SetFRXDataSession()
    m.liSelect = SELECT()
    SELECT 0
    IF VARTYPE(tFRXFile) # "C" OR NOT FILE(tFRXFile) 
      *&* don't know if it is built-in
      *&* and don't care at this point
      *&* automatic failure
    ELSE
      TRY
        USE (tFRXFile) ;
         ALIAS  (THIS.FRXTempAlias) AGAIN SHARED
        DO CASE
        CASE EMPTY(Tag) AND EMPTY(Tag2) && Not checking EMPTY(Expr),
                                        && to keep orientation if listed
                                        && in an attempt to match the original
                                        && layout's aspect ratio 
                                        && to fit all the controls on the page.
                                        && You can revise this method, if you want to, to
                                        && keep ONLY orientation and strip the rest.
                                        && You can also include the check for EMPTY(Expr) and 
                                        && strip everything **if** your FRXs include the 
                                        && orientation in Picture as a user overide.
                                        && This would be optimal for landscape reports.
          m.llSuccess = .T.
          *&* whether built-in or not, we're good to go
        CASE ISREADONLY()
          *&* failure -- might be built-in, might not
        OTHERWISE
          SCATTER FIELDS Expr,Tag, Tag2 MEMO ;
            NAME THIS.OldFRXSetup
          BLANK FIELDS Expr, Tag, Tag2
          m.llSuccess = .T.
        ENDCASE
      CATCH WHEN .T.
        *&* failure of any kind
      ENDTRY
    ENDIF
    IF USED (THIS.FRXTempAlias)
      USE IN (THIS.FRXTempAlias)
    ENDIF
    SELECT (m.liSelect)
    THIS.ResetDataSession()
    RETURN m.llSuccess

  ENDPROC

  PROCEDURE RestoreSavedFRXSetup(tFRXFile) 
    LOCAL m.llSuccess, m.liSelect
    IF ISNULL(THIS.OldFRXSetup)
      *&* automatic failure, nothing to restore
    ELSE
      TRY
        THIS.SetFRXDataSession()
        m.liSelect = SELECT()
        SELECT 0
        USE (tFRXFile) ;
          ALIAS (THIS.FRXTempAlias) AGAIN SHARED
        GO TOP
        GATHER NAME THIS.OldFRXSetup MEMO
        m.llSuccess = .T.
      CATCH WHEN .T.
        *&* failure of any kind
      FINALLY
        IF USED (THIS.FRXTempAlias)
          USE IN (THIS.FRXTempAlias)
        ENDIF
        SELECT (m.liSelect)
        THIS.OldFRXSetup = NULL
        THIS.ResetDataSession()
      ENDTRY
    ENDIF
    RETURN m.llSuccess
  ENDPROC

  PROCEDURE MultipleSetupsOnePrinter(toSetupList) 
    IF ( ISNULL(toSetupList) OR ;
        (TYPE("toSetupList.Count") # "N") OR ;
        (toSetupList.Count = 0) )
      *&* early quit  
      RETURN .F.
    ELSE
      THIS.SetFRXDataSession()
      LOCAL m.lcPrinter, m.lcSetup, ;
            m.liIndex, m.liSelect, m.llSuccess
      m.liSelect = SELECT()
      SELECT 0
      THIS.UsePrinterSetupTableExclusive()      
      DO CASE
      CASE NOT USED(THIS.FRXPrintSourceAlias) 
         m.llSuccess = .F.
      CASE ISREADONLY(THIS.FRXPrintSourceAlias) OR ;
           NOT ISEXCLUSIVE(THIS.FRXPrintSourceAlias)
         m.llSuccess = .T.
         FOR m.liIndex = 1 TO toSetupList.Count
           m.lcSetup = toSetupList.GetKey(m.liIndex)
           LOCATE FOR ALLTR(UPPER(Name)) == ;
             ALLTR(UPPER(m.lcSetup))
           IF NOT FOUND()
              m.llSuccess = .F.
              EXIT
           ENDIF  
         ENDFOR
      OTHERWISE         
        m.liIndex = 1
        m.lcSetup = toSetupList.GetKey(m.liIndex)
        m.llSuccess = .T.
        LOCATE FOR ALLTR(UPPER(Name)) == ;
          ALLTR(UPPER(m.lcSetup))
        *&* we're only checking for the first one          
        IF NOT FOUND()
          *&* we're going to add them
          GO TOP
          INSERT BLANK BEFORE
          GO TOP
          THIS.DoStatus(PICK_PRINTERSETUP1_LOC)
          SYS(1037,1)
          m.lcPrinter = THIS.GetPrinterSetupDeviceInfo(Expr)
          REPLACE Name WITH m.lcSetup
          DO WHILE m.liIndex < toSetupList.Count
            m.liIndex = m.liIndex + 1
            m.lcSetup = toSetupList.GetKey(m.liIndex)
            GO TOP
            INSERT BLANK BEFORE
            GO TOP && probably not required, but doesn't hurt
            THIS.DoStatus(PICK_PRINTERSETUP2_LOC)
            SYS(1037,1)
            DO WHILE .T.
              IF THIS.GetPrinterSetupDeviceInfo(Expr) == m.lcPrinter
                REPLACE Name WITH m.lcSetup
                EXIT
              ELSE
                BLANK FIELDS Expr, Tag, Tag2
                THIS.DoMessage(PICK_SAME_PRINTER_ALL_SETUPS_LOC, ;
                  MB_ICONEXCLAMATION)
                SYS(1037,1)
              ENDIF
            ENDDO
          ENDDO
          WAIT CLEAR
        ENDIF
      ENDCASE
      IF USED(THIS.FRXPrintSourceAlias)
         USE IN (THIS.FRXPrintSourceAlias)
      ENDIF   
      SELECT (liSelect)
      THIS.ResetDataSession()
    ENDIF
    RETURN m.llSuccess
  ENDPROC
  
  *&* End PUBLIC/Callable methods (PROTECTED from here down)
  
  PROTECTED PROCEDURE UsePrinterSetupTableExclusive
    LOCAL m.lcSafety 
    IF FILE(THIS.PrinterSetupTable) 
       *&* can be built in, hence "FILE(" check
       TRY 
          USE (THIS.PrinterSetupTable) ;
            ALIAS (THIS.FRXPrintSourceAlias) EXCLUSIVE
       CATCH WHEN .T.
          TRY 
            USE (THIS.PrinterSetupTable) ;
              ALIAS (THIS.FRXPrintSourceAlias) ;
              AGAIN SHARED
          CATCH WHEN .T.
          ENDTRY
       ENDTRY
    ELSE
       m.lcSafety = SET("SAFETY")
       SET SAFETY OFF
       CREATE CURSOR (THIS.FRXTempAlias) (onefield l)
       CREATE REPORT (THIS.PrinterSetupTable) ;
         FROM DBF(THIS.FRXTempAlias)
       USE IN (THIS.FRXTempAlias)
       USE (THIS.PrinterSetupTable) ;
         ALIAS (THIS.FRXPrintSourceAlias) EXCLUSIVE
       ZAP
       IF m.lcSafety = "ON"
         SET SAFETY ON
       ENDIF
     ENDIF
  ENDPROC     

  PROTECTED PROCEDURE Setup()
    THIS.Declares()
    THIS.OldPrinterName = SET("PRINTER",3)
    THIS.SetFRXDataSession()
    USE (THIS.PrinterSetupTable) IN 0 ;
      ALIAS (THIS.FRXPrintSourceAlias) AGAIN SHARED
    THIS.SetPrinterOptions(THIS.FRXPrintSetups.GetKey(1), .T.)
    *&* The page height and width of the printer
    *&* we want to use is now
    *&* set up before the Engine looks at it.
    SELECT 0 && leave ourselves in a safe place for FRX to be added
    THIS.ResetDataSession()
    *&* Now tell the Engine to use the setup we've altered
    SET PRINTER TO NAME (THIS.CurrentPrinterName)
  ENDPROC

  PROTECTED PROCEDURE Cleanup()
    LOCAL laDummy[1]
    THIS.SetFRXDataSession()
    *&* return the current printer's setup data
    *&* to a pristine state:
    THIS.SaveRestorePrinterSetupData(.F.)
    *&* return the FRX's printer setup data
    *&* to its original state:
    IF NOT (ISNULL(THIS.OldFRXSetup) OR ;
        THIS.RestoreSavedFRXSetup(THIS.CommandClauses.FILE))
      THIS.DoMessage(FAILED_FRXSETUP_RESTORE_LOC,MB_ICONEXCLAMATION)
    ENDIF
    THIS.ResetDataSession()
    IF ADLLS(laDummy) > 0 AND ;
       ASCAN(laDummy,"DeleteDC",1,0,2,9) > 0
       = DeleteDC(THIS.HDC)   
    ENDIF             
    THIS.HDC = -1
    *&* return the current printer to
    *&* its original state
    *&* we didn't adjust any of the attributes
    *&* of the old setup and don't need to restore them
    SET PRINTER TO NAME (THIS.OldPrinterName)
  ENDPROC

  PROTECTED PROCEDURE SaveRestorePrinterSetupData(tlSave)
    *&* this method does not change data sessions --
    *&* it is protected and expects to be in the
    *&* right place to do its work
    IF USED(THIS.FRXPrintSourceAlias) AND ;
        (tlSave OR ;
        NOT ISNULL(THIS.CurrentPrinterSetupDefaults))
      LOCAL m.liSelect
      m.liSelect = SELECT()
      SELECT * FROM (THIS.FRXPrintSourceAlias) WHERE .F. ;
        INTO CURSOR (THIS.FRXTempAlias) READWRITE
      SELECT (THIS.FRXTempAlias)
      APPEND BLANK
      IF tlSave
        SYS(1037,2)
        SCATTER FIELDS Expr,Tag, Tag2 MEMO ;
          NAME THIS.CurrentPrinterSetupDefaults
      ELSE
        GATHER NAME THIS.CurrentPrinterSetupDefaults MEMO
        = ResetDC(THIS.HDC,ALLTRIM(Tag2))
        SYS(1037,3)
        THIS.CurrentPrinterSetupDefaults = NULL
      ENDIF
      USE IN (THIS.FRXTempAlias)
      SELECT (m.liSelect)
    ENDIF
  ENDPROC

  PROTECTED PROCEDURE ProcessPages(;
    tiSetupIndex, tiPageStart, tiPageEnd)
    *&* structure the "embracing" printer calls here
    LOCAL m.liPage, m.l, m.t, m.w, m.h
    
    THIS.SetPrinterOptions( ;
           THIS.FRXPrintSetups.GetKey(m.tiSetupIndex))

    THIS.SizePages(@m.l, @m.t, @m.w, @m.h)

    FOR m.liPage = m.tiPageStart TO m.tiPageEnd
      = StartPage(THIS.HDC)
      THIS.OutputPage(m.liPage, THIS.HDC, ;
                 LISTENER_DEVICE_TYPE_HDC, ;
                 m.l, m.t, m.w ,m.h)
      = EndPage(THIS.HDC)
    ENDFOR

  ENDPROC
  
  PROTECTED PROCEDURE SizePages(m.tl, m.tt, m.tw, m.th)
    *&* coordinates and sizes are passed by reference

    LOCAL m.xdpi, m.ydpi, m.pw, m.ph, m.llScaleAdjust  

    m.pw = THIS.GetPageWidth()  && what the Engine thinks the page dimensions
    m.ph = THIS.GetPageHeight() && are for the full report, based on the first setup

    m.tw = GetDeviceCaps(THIS.HDC, PHYSICALWIDTH)
    m.th = GetDeviceCaps(THIS.HDC, PHYSICALHEIGHT)

    m.xdpi = GetDeviceCaps(THIS.HDC, LOGPIXELSX )
    m.ydpi = GetDeviceCaps(THIS.HDC, LOGPIXELSY)

    IF THIS.ScalePages= "RETAIN"
      *&* what does the Engine *think* is the aspect ratio?
      *&* what is the real aspect ratio?
      *&* do they match?
      m.llScaleAdjust =  (m.tw < m.th AND m.pw >= m.ph) OR ;
        (m.th < m.tw AND m.ph >= m.pw) OR ;
        (m.tw = m.th AND m.ph # m.pw)
    ENDIF
    
    m.tl = GetDeviceCaps(THIS.HDC, PHYSICALOFFSETX)
    m.tt = GetDeviceCaps(THIS.HDC, PHYSICALOFFSETY)

    #IF USE_DEFAULT_DPI_GRAPHICS  
       *&* we can't work with the printer dpi,
       *&* VFP is working in the default when it 
       *&* gets a Graphics object from an HDC.
       *&* Start by fixing page offsets.
       m.tl =  m.tl * (DEFAULT_DPI_GRAPHICS / m.xdpi) 
       m.tt =  m.tt * (DEFAULT_DPI_GRAPHICS / m.ydpi) 
       
       DO CASE
       CASE m.llScaleAdjust
         *&* fix the larger of the two dimensions
         *&* to fit the available space
         IF (m.tw > m.th) AND (m.ph > m.pw)
           m.tw = INT(m.th * (m.pw/m.ph) )                            
         ELSE
           m.th = INT(m.tw * (m.ph/m.pw) )        
         ENDIF
         m.th = INT(m.th * (DEFAULT_DPI_GRAPHICS / m.xdpi)) 
         m.tw = INT(m.tw * (DEFAULT_DPI_GRAPHICS / m.ydpi))           
       CASE THIS.ScalePages == "CLIP"        
         *&* take what the Engine expected and fix the units
         m.tw = INT(m.pw * (DEFAULT_DPI_GRAPHICS / LISTENER_DPI))
         m.th = INT(m.ph * (DEFAULT_DPI_GRAPHICS / LISTENER_DPI))          
       CASE .F.
         *&* you could change the way the thing fits on the page (for example,
         *&* four pages to the page, or envelope printing using a Title or Summary band) 
         *&* You need to keep track of the appropriate 
         *&* m.tl and m.tt values as you output each page section.
       OTHERWISE 
         *&* fix units to scale and stretch/fill by default
         m.tw = INT(m.tw * (DEFAULT_DPI_GRAPHICS / m.xdpi))
         m.th = INT(m.th * (DEFAULT_DPI_GRAPHICS / m.ydpi))          
       ENDCASE
    #ELSE      
       DO CASE
       CASE m.llScaleAdjust
         *&* fix the larger of the two dimensions
         *&* to fit the available space
         IF (m.tw > m.th) AND (m.ph > m.pw)
           m.tw = INT((m.th - m.tt) * (m.pw/m.ph) )                            
         ELSE
           m.th = INT((m.tw - m.tl)* (m.ph/m.pw) )        
         ENDIF
       CASE THIS.ScalePages == "CLIP"
         *&* take what the Engine expected and fix the units              
         m.tw = INT(m.pw * ( m.xdpi / LISTENER_DPI))
         m.th = INT(m.ph * ( m.ydpi / LISTENER_DPI))          
       CASE .F.
         *&* see notes on other ideas above
       OTHERWISE 
         *&* we're good to go to scale and 
         *&* stretch/fill by default
       ENDCASE
    #ENDIF      
     m.tw = m.tw - (m.tl*2)      
     m.th = m.th - (m.tt*2)
     m.tl = 0
     m.tt = 0
     *&* see note above in CASE .F. section --
     *&* 0 values will not always be appropriate 
     *&* for m.tl and m.tt, depending on how
     *&* you are trying to lay out your page.
  ENDPROC           

  PROTECTED PROCEDURE SetPrinterOptions( ;
    tcWhichSetup, tlSaveExistingOptions)
    *&* switch printer definitions
    *&* expects appropriate datasession to be
    *&* available with printer definition table
    IF USED(THIS.FRXPrintSourceAlias)
      SELECT (THIS.FRXPrintSourceAlias)
      SELECT * FROM (THIS.FRXPrintSourceAlias) WHERE ;
        ALLTR(UPPER(Name)) == ALLTR(UPPER(tcWhichSetup)) ;
        INTO CURSOR (THIS.FRXPrintTargetAlias)
      IF USED(THIS.FRXPrintTargetAlias)
        IF NOT EOF(THIS.FRXPrintTargetAlias)
          SELECT (THIS.FRXPrintTargetAlias)
          THIS.GetHDC()
          IF THIS.HDC # -1
            IF tlSaveExistingOptions
              THIS.SaveRestorePrinterSetupData(.T.)
            ENDIF
            = ResetDC(THIS.HDC,ALLTRIM(Tag2))
          ENDIF
        ENDIF
        USE IN (THIS.FRXPrintTargetAlias)
      ENDIF
    ENDIF
    IF USED("frx")
      SELECT frx
    ELSE
      SELECT 0
    ENDIF
  ENDPROC

  PROTECTED PROCEDURE GetHDC()
    IF THIS.HDC = -1
      *&* create one
      LOCAL m.lcDevice, m.lcDriver, m.liSelect
      IF USED(THIS.FRXPrintTargetAlias)
        m.liSelect = SELECT()
        SELECT (THIS.FRXPrintTargetAlias)
        m.lcDevice = THIS.GetPrinterSetupDeviceInfo(Expr,"DEVICE")
        IF EMPTY(m.lcDevice)
          m.lcDevice = SET("PRINTER",3)
        ENDIF
        THIS.CurrentPrinterName = m.lcDevice
        m.lcDriver = THIS.GetPrinterSetupDeviceInfo(Expr,"DRIVER")
        IF EMPTY(m.lcDriver)
          m.lcDriver = "winspool"
        ENDIF
        THIS.HDC = CreateDC( m.lcDriver, m.lcDevice, CHR(0), 0 )
        SELECT (m.liSelect)
      ELSE
        THIS.HDC = -1
      ENDIF
    ENDIF
  ENDPROC

  PROTECTED PROCEDURE ResetDataSession
    IF THIS.FRXDATASESSION # -1 
       IF (TYPE("THIS.CommandClauses.StartDataSession")="N")
         SET DATASESSION TO (THIS.CommandClauses.StartDataSession)
       ELSE
         DODEFAULT()
       ENDIF         
    ENDIF
  ENDPROC

  PROTECTED PROCEDURE GetPrinterSetupDeviceInfo(tExpr, tWhat)
    LOCAL m.liLines, m.liLine, laExpr[1], m.lcItem
    IF EMPTY(tWhat)
      tWhat = "DEVICE"
    ENDIF
    m.lcItem = ""
    m.liLines = ALINES(laExpr,tExpr)
    m.liLine = ASCAN(laExpr,UPPER(tWhat)+"=",1,m.liLines,1,5)
    IF m.liLine > 0
      m.lcItem = SUBSTR(laExpr[m.liLine],AT("=",laExpr[m.liLine]) + 1)
    ENDIF
    RETURN m.lcItem
  ENDPROC

  PROTECTED PROCEDURE Declares
  
    LOCAL laDeclares[1], m.liDeclares
    m.liDeclares = ADLLS(laDeclares)
    
    IF liDeclares = 0 OR ;
       ASCAN(laDeclares,"GetLastError",1,liDeclares,2,9) = 0

       DECLARE INTEGER GetLastError IN WIN32API

    ENDIF       

    IF liDeclares = 0 OR ;
       ASCAN(laDeclares,"ResetDC",1,liDeclares,2,9) = 0

       DECLARE INTEGER ResetDC IN gdi32 ;
         INTEGER hdc, ;
         STRING @ lpInitData

    ENDIF       

    IF liDeclares = 0 OR ;
       ASCAN(laDeclares,"CreateDC",1,liDeclares,2,9) = 0

       DECLARE INTEGER CreateDC IN gdi32 ;
         STRING lpszDriver, ;
         STRING lpszDevice, ;
         STRING lpszOutput, ;
         STRING lpdvmInit

    ENDIF       

    IF liDeclares = 0 OR ;
       ASCAN(laDeclares,"StartDoc",1,liDeclares,2,9) = 0

       DECLARE INTEGER StartDoc IN gdi32 ;
         INTEGER hdc, ;
         STRING @ lpdi

    ENDIF       

    IF liDeclares = 0 OR ;
       ASCAN(laDeclares,"EndDoc",1,liDeclares,2,9) = 0

       DECLARE INTEGER EndDoc IN gdi32 ;
         INTEGER hdc

    ENDIF       

    IF liDeclares = 0 OR ;
       ASCAN(laDeclares,"StartPage",1,liDeclares,2,9) = 0

       DECLARE INTEGER StartPage IN gdi32 ;
         INTEGER hdc

    ENDIF       

    IF liDeclares = 0 OR ;
       ASCAN(laDeclares,"EndPage",1,liDeclares,2,9) = 0

       DECLARE INTEGER EndPage IN gdi32 ;
         INTEGER hdc

    ENDIF       

    IF liDeclares = 0 OR ;
       ASCAN(laDeclares,"DeleteDC",1,liDeclares,2,9) = 0

       DECLARE INTEGER DeleteDC IN gdi32 ;
         INTEGER hdc

    ENDIF       

    IF liDeclares = 0 OR ;
       ASCAN(laDeclares,"GetDeviceCaps",1,liDeclares,2,9) = 0

       DECLARE INTEGER GetDeviceCaps IN gdi32 ;
         INTEGER hdc, ;
         INTEGER nIndex

    ENDIF         

  ENDPROC


ENDDEFINE


DEFINE CLASS OleAwareReportListener AS ;
  LISTENER_SUPERCLASS OF LISTENER_SUPERCLASSLIB

  PROTECTED IsOle

  ThrowOleError = .F.
  IsOle = ( INLIST(_VFP.STARTMODE, ;
              VFPSTARTMODE_APPOBJ, ; 
              VFPSTARTMODE_COMEXE, ;
              VFPSTARTMODE_INPROCDLL,;
              VFPSTARTMODE_MTDLL ))

  PROCEDURE ERROR(nError, cMethod, nLine)
    DODEFAULT(nError,cMethod,nLine)
    IF (NOT THIS.lIgnoreErrors) AND ;
        THIS.IsOle AND THIS.ThrowOleError
      IF EMPTY(THIS.LastErrorMessage)
        THIS.LastErrorMessage = MESSAGE() + ", line " + TRANSFORM(nLine)
      ENDIF
      COMRETURNERROR( _VFP.SERVERNAME, THIS.LastErrorMessage)
    ENDIF
  ENDPROC

  PROCEDURE ThrowOleError_Assign(tVal)
    IF VARTYPE(m.tVal) = "L"
      THIS.ThrowOleError = tVal
    ENDIF
  ENDPROC

ENDDEFINE

