llIsConfig = VARTYPE(THIS.oConfig) = "O"
IF llIsConfig
    THISFORM.oConfig.cLastFile = THIS.oHelp.cFileName
    IF !ISNULL(THIS.oHelp.oTopic) AND THIS.oHelp.oTopic.Pk # "CONFIG"
        THISFORM.oConfig.cLastTopic = THIS.oHelp.oTopic.Pk
    ENDIF

    IF THIS.WINDOWSTATE = 0
        THISFORM.oConfig.nTop = THIS.TOP
        THISFORM.oConfig.nLeft = THIS.LEFT
        THISFORM.oConfig.nHeight= THIS.HEIGHT
        THISFORM.oConfig.nWidth = THIS.WIDTH
        THISFORM.oConfig.nSplitter = THIS.oSplitter.LEFT
    ENDIF

    THISFORM.oConfig.nViewMode = THIS.nViewMode
    THISFORM.oConfig.cOutputPath = THIS.oHelp.cOutputPath
ENDIF



THIS.TOP = THIS.oConfig.nTop
THIS.LEFT = THIS.oConfig.nLeft
THIS.oSplitter.LEFT = THIS.oConfig.nSplitter
THIS.nViewMode = THIS.oConfig.nViewMode

*** First Time Sizing
IF THIS.TOP = 0 AND THIS.LEFT=0
    IF  SYSMETRIC(1) < 900
        THIS.WIDTH = SYSMETRIC(1) - 10
        THIS.HEIGHT = SYSMETRIC(2) - 10
    ELSE
        THIS.WIDTH = 840
        THIS.HEIGHT = 560
    ENDIF
    THIS.AUTOCENTER = .T.
ELSE
    THIS.HEIGHT = THIS.oConfig.nHeight
    THIS.WIDTH = THIS.oConfig.nWidth
ENDIF


************************************************************************
* GetMonitorStatistics
****************************************
***  Function: Returns information about the desktop screen
***            Can be used to check for desktop width and size
***            and determine when a second monitor is disabled
***            and layout needs to be adjusted to keep the
***            window visible.
***      Pass:
***    Return:  Monitor Object
************************************************************************
FUNCTION GetMonitorStatistics()

    #DEFINE SM_XVIRTUALSCREEN 76
    #DEFINE SM_YVIRTUALSCREEN 77
    #DEFINE SM_CXVIRTUALSCREEN 78
    #DEFINE SM_CYVIRTUALSCREEN 79
    #DEFINE SM_CMONITORS 80
    #DEFINE SM_CXFULLSCREEN 16
    #DEFINE SM_CYFULLSCREEN 17


    DECLARE INTEGER GetSystemMetrics IN user32 INTEGER nIndex

    loMonitor = CREATEOBJECT("EMPTY")
    ADDPROPERTY( loMonitor,"Monitors",GetSystemMetrics(SM_CMONITORS) )
    ADDPROPERTY( loMonitor,"VirtualWidth",GetSystemMetrics(SM_CXVIRTUALSCREEN) )
    ADDPROPERTY( loMonitor,"VirtualHeight",GetSystemMetrics(SM_CYVIRTUALSCREEN) )
    ADDPROPERTY( loMonitor,"ScreenHeight",GetSystemMetrics(SM_CYFULLSCREEN) )
    ADDPROPERTY( loMonitor,"ScreenWidth",GetSystemMetrics(SM_CXFULLSCREEN) )

    RETURN loMonitor
ENDFUNC
*  wwAPI ::  GetMonitorStatistics



loMonitor = GetMonitorStatistics()

IF THISFORM.LEFT > loMonitor.VirtualWidth
    THISFORM.LEFT = 1
ENDIF

************************************************************************
*  FixMonitorPosition
****************************************
***  Function: Fixes a FoxPro form to fit on the screen and become
***            visible on activation even if the location is on
***            no longer visible screen
***            This function is useful if you store screen positions
***            in configuration files and have a screen on a second
***            monitor that is no longer available
***    Assume:
***      Pass: loForm    -  The form to fix
***    Return: nothing
************************************************************************
FUNCTION FixMonitorPosition(loForm,lnWidth, lnHeight)
    LOCAL loMonitor

    *** Retrieve statistics about virtual and active screen
    loMonitor = GetMonitorStatistics()

    IF EMPTY(lnWidth)
        lnWidth = loMonitor.VirtualWidth - 10
    ENDIF
    IF EMPTY(lnHeight)
        lnHeight = loMonitor.VirtualHeight - 10
    ENDIF

    *** If the monitor is on a non-visible screen move it over
    *** to the current screen

    *** Fix top and left first - on another screen most likely
    IF loForm.LEFT > loMonitor.VirtualWidth - 10
        loForm.LEFT = 5
    ENDIF
    IF loForm.TOP > loMonitor.VirtualHeight - 50
        loForm.TOP = 5
    ENDIF

    *** Now fix the width if larger than screen
    IF loForm.WIDTH > loMonitor.VirtualWidth - 10
        loForm.WIDTH = lnWidth -  10
        loForm.LEFT = 5
    ENDIF
    IF loForm.HEIGHT > loMonitor.VirtualHeight - 10
        loForm.HEIGHT = lnHeight - 10
        loForm.TOP = 5
    ENDIF

ENDFUNC
*   FixMonitorPosition


*** Try to resize the window to saved pos
IF wwt_cfg.ypos # 0
    THISFORM.TOP=wwt_cfg.ypos
    THISFORM.LEFT=wwt_cfg.xpos
    THISFORM.HEIGHT=wwt_cfg.HEIGHT
    THISFORM.WIDTH=wwt_cfg.WIDTH
    IF !THISFORM.lVerticalSplitter
        THISFORM.shpSplitter.LEFT = wwt_cfg.SliderLeft
    ELSE
        THISFORM.shpSplitter.TOP = wwt_cfg.SliderLeft
    ENDIF
ENDIF

*** Check and fix for multi-monitor position
FixMonitorPosition(THISFORM)
